var total_count, current_count, start, limit, loader, progress;
function getProgress(self) {
	jQuery('#es-progress').css('display','inline-block');
	var params = {
		type: 'POST',
		dataType:'text',
		async:true,
		url: ajaxurl,
		data: {
			action: 'es_list_cleanup',
			start : self.start,
			current_count : self.current_count,
			done: self.done || false
		},
		success: function(res) {
			var obj = jQuery.parseJSON( res );
			self.start = obj.start;
			self.loader = Math.round(100 - ((self.current_count/self.total_count) * 100));
			self.current_count = self.current_count - self.limit;
			self.loader = (self.current_count <= 0 ) ?  100 : self.loader;
			var per = self.loader+'%';
			if(self.current_count > 0){
				getProgress(self);
				jQuery(self).find('span').text(per);
			}else{
				self.done = true;
				getProgress(self);
				jQuery(self).removeAttr("disabled");
				jQuery('.es-notice-done').show();
				jQuery('.es-notice').hide();
				jQuery(self).find('span').text(per);
        				// jQuery(self).find('span').text('Cleanup My List');
        				jQuery(self).hide('slow');
        				location.reload();
        			}
        		},
        		error: function(res) {
        			console.log(res)
        		}
        	};
        	jQuery.ajax(params);
        }
// List cleanup
jQuery(document).on('click', '#es-cleanup' , function(e) {
	e.preventDefault();
	var self = this;
	self.total_count = self.current_count = es_admin_data.total_subscribers;
	self.current_count = (typeof(self.current_count) !== 'undefined') ? self.current_count : jQuery('.es_total_subscribers').html();
	self.start = (typeof(self.start) !== 'undefined') ? self.start : 0 ;
	self.limit = 5;
	if(progress == null || progress == 100){
		jQuery(self).find('span').text('0%');
		progress = 0;
		getProgress(self);
		jQuery(this).attr('disabled', true);
		jQuery('.es-notice').show();
	}
});

jQuery(document).ready(function($){

	// timepicker
	var date_str = es_admin_data.current_date;
	var d = new Date(date_str);
	var n = d.getHours() + 1;
	let current_set_date = jQuery( '#es_schedule_date' ).val();
	//datepicker
	jQuery('#es_schedule_date').datepicker({
		dateFormat: 'yy-mm-dd',
		showOtherMonths: true,
		selectOtherMonths: true,
		changeMonth: true,
		changeYear: true,
		minDate: new Date(date_str),
		showButtonPanel: false,
	});

	if( '' === current_set_date ) {
		jQuery('#es_schedule_date').datepicker( "setDate", new Date(date_str));
	}

	let current_set_time = jQuery( '#es_schedule_time' ).val();

	jQuery('.es_schedule_time').timepicker({
		timeFormat: 'h:mm p',
		interval: 60,
		startTime: new Date(0,0,0,n,0,0),
		dynamic: true,
		dropdown: true,
		scrollbar: false,
		defaultTime:new Date(0,0,0,n,0,0),
		maxTime: '23:00pm', // 11:45:00 AM,
		minTime: new Date(0,0,0,n,0,0)
	});

	if( '' !== current_set_time ) {
		jQuery( '#es_schedule_time' ).timepicker( 'setTime', current_set_time );
	}

	jQuery('#es_schedule_date').change(function() {
		var today = jQuery.datepicker.formatDate('yy-mm-dd', d);
		var m = (today !== jQuery('#es_schedule_date').val() ) ? 0 : n;
		jQuery('.es_schedule_time').data('TimePicker').options.minTime = new Date(0,0,0,m,0,0);
		jQuery('.es_schedule_time').data('TimePicker').options.startTime = new Date(0,0,0,m,0,0);
		jQuery('.es_schedule_time').data('TimePicker').options.defaultTime = new Date(0,0,0,m,0,0);
	});

	//post digest change feild
	if(jQuery('#is_post_digest').is(":checked")){
		jQuery('.ig-es-campaign-number-of-post-wrapper, #post_digest_template_id, #ig-es-campaign-post-digest-scheduler-wrapper').show();
		jQuery('#base_template_id').hide();
	}
	jQuery(document).on('change', '#is_post_digest' , function(e) {
		let campaign_type = '';
		let campaign_heading_text = '';
		if(jQuery(this).is(":checked")){
			jQuery('.ig-es-campaign-number-of-post-wrapper, #post_digest_template_id, .ig-es-campaign-post-digest-scheduler-wrapper').show();
			jQuery('#base_template_id').hide();
			campaign_type         = 'post_digest';
			campaign_heading_text = jQuery('.campaign-heading-label').data('post-digest-type-text');
		}else{
			jQuery('#base_template_id').show();
			jQuery('.ig-es-campaign-number-of-post-wrapper, #post_digest_template_id, .ig-es-campaign-post-digest-scheduler-wrapper').hide();
			jQuery('input#campaign_type').val('post_notification');
			campaign_type         = 'post_notification';
			campaign_heading_text = jQuery('.campaign-heading-label').data('post-notification-type-text');
		}
		jQuery('input#campaign_type').val(campaign_type);
		jQuery('.campaign-heading-label').text(campaign_heading_text);
	});

	//scheduler option change
	jQuery(document).on('change', '#field_interval_type select', function(){
		var interval_type_val = jQuery(this).val();
		jQuery('.es_intervals').hide();
		if( 'daily' == interval_type_val ){
			jQuery('#field_time_of_day').addClass('w-full').show();
		} else if( 'weekly' == interval_type_val ){
			jQuery('#field_time_of_day').removeClass('w-full').addClass('w-1/2').show();
			jQuery('#field_week_day').show();
		} else if( 'monthly' == interval_type_val ){
			jQuery('#field_time_of_day').removeClass('w-full').addClass('w-1/2').show();
			jQuery('#field_month_day').show();
		} else if( 'immediately' == interval_type_val ){
			jQuery('.es_intervals').hide();
		}
	});
	jQuery('#field_interval_type select').trigger('change');
	
	if( 'function' === typeof jQuery.fn.ig_es_select2 ) {
		jQuery('.ig-es-form-multiselect').ig_es_select2();
	}

	jQuery('body')
		.on('click', '.ig-es-delete-attachment', function (e) {
			e.preventDefault();
			jQuery(this).closest('.ig-es-attachment').remove();
		})
		.on('click', '.ig-es-add-attachment', function (e) {
			e.preventDefault();
			jQuery('.ig-es-add-attachment').removeClass('clicked');
			jQuery(this).addClass('clicked');
			if ( ! wp.media.frames.ig_es_attachments ) {
				// Create the media frame.
				wp.media.frames.ig_es_attachments = wp.media({
					// Set the title of the modal.
					title: es_admin_data.i18n_data.add_attachment_text,
					button: {
						text: es_admin_data.i18n_data.add_attachment_text,
					},
					multiple: false,
					states: [
						new wp.media.controller.Library({
							filterable: 'all',
							multiple: true
						})
					]
				});
				
				// When a file is selected, run a callback.
				wp.media.frames.ig_es_attachments.on('selection:toggle library:selection:add', function () {
					let attachment = wp.media.frames.ig_es_attachments.state().get('selection').first();
					if ( 'undefined' !== typeof attachment ) {
						let attachment_data    = attachment.toJSON();
						let file_size_in_bytes = attachment_data.filesizeInBytes;
						if ( file_size_in_bytes > es_admin_data.attachment_max_file_size_in_bytes ) {
							alert( es_admin_data.i18n_data.attachment_file_size_exceeded_message );
							jQuery('.media-button-select').attr('disabled','disabled')
							return;
						} else {
							jQuery('.media-button-select').removeAttr('disabled');
						}
					}
				});

				// When a user click on Add file button.
				wp.media.frames.ig_es_attachments.on('select', function () {
					let attachment = wp.media.frames.ig_es_attachments.state().get('selection').first().toJSON(),
					clicked_button = jQuery('.ig-es-add-attachment.clicked'),
						el = jQuery(clicked_button).closest('.ig-es-attachments-wrapper').find('.ig-es-attachment').eq(0).clone(),
						attachment_field_name = el.find('input').data('name');
					el.find('.ig-es-attachment-thumbnail').attr('src', attachment.icon);
					el.find('.ig-es-attachment-label').html(attachment.filename);
					// Check if we have to add the attachment in sequence message.
					if ( attachment_field_name.indexOf('{seq_message_id}') > 0 ) {
						let seq_message_id    = jQuery(clicked_button).closest('.es_seq_right_wrapper').data('seq-id');
						attachment_field_name = attachment_field_name.replace('{seq_message_id}', seq_message_id );
					}
					else if ( attachment_field_name.indexOf('{action_id}') > 0 ) {
						let action_id    = jQuery(clicked_button).closest('.ig-es-action').data('action-number');
						attachment_field_name = attachment_field_name.replace('{action_id}', action_id );
					}
					el.find('input').attr('name', attachment_field_name).val(attachment.id);
					el.show();
					jQuery(clicked_button).closest('.ig-es-attachments-wrapper').find('.ig-es-attachments').append(el);
					jQuery(clicked_button).removeClass('clicked');
				});
			}
			wp.media.frames.ig_es_attachments.open();
		});

	// Sequence JS
	jQuery(document).on( 'click', '#es_add_next_seq_email', function(){
		var pre_seq_ids = [];
		jQuery('.es_seq_right_wrapper').each(function(){
			pre_seq_ids.push(jQuery(this).attr('data-seq-id'));
		});
		var pre_seq_id = (pre_seq_ids.length) ? Math.max.apply(Math, pre_seq_ids) : 1; 
		var cur_seq_id = parseInt(pre_seq_id) + 1;
		jQuery.ajax({
			type: 'POST',
			url: ajaxurl,
			dataType: 'json',
			data: {
				action: 'get_seq_action_row',
				pre_seq_id: pre_seq_id
			},
			success: function(response) {	
				jQuery('ul#sequence_email_templates').append(response.left_action_row);
				jQuery('ul#sequence_email_templates .es_seq_list').removeClass('active');
				jQuery('li.es_seq_list[data-seq-id='+cur_seq_id+']').addClass('active');
				jQuery('.es_seq_right_wrapper[data-seq-id='+pre_seq_id+']').hide();
				jQuery('.es_seq_right_wrapper').hide();
				jQuery('#editing_area').append(response.content_action_row);
				jQuery('.es_seq_right_wrapper').last().attr('data-seq-id', cur_seq_id).addClass('active').show();
				// jQuery('.es_sequence_settings').html(response.settings_action_row);
				
				// Convert html textarea area into WP Editor.
				jQuery( '#edit' + response.id ).wp_js_editor();
				let new_conditions_elem = jQuery('#editing_area .es_seq_right_wrapper:last-child .ig-es-conditions');
				
				// Register JS functions to handle rules added/removed/changed events for new sequence message
				jQuery(document).trigger('bind_campaign_rules_events', [{conditions_elem: new_conditions_elem}]);
			}
		});
	});

	//delete this emails from seq
	jQuery(document).on( 'click', '.delete_email', function( event ){
		event.stopPropagation();
		if(confirm(es_admin_data.i18n_data.delete_single_sequence_message)){
			var seq_id = jQuery(this).parents('.es_seq_list').data('seq-id');
			if(jQuery('.es_seq_list[data-seq-id="'+seq_id+'"]').next().length){
				jQuery('.es_seq_list[data-seq-id="'+seq_id+'"]').next().trigger('click');
			}else{
				jQuery('.es_seq_list[data-seq-id="'+seq_id+'"]').prev().trigger('click');
			}
			jQuery('.es_seq_list[data-seq-id="'+seq_id+'"]').remove();
			jQuery('.es_seq_right_wrapper[data-seq-id="'+seq_id+'"]').remove();
	    } else{
	        return false;
	    }
	});

	//activate left panel seq
	jQuery(document).on( 'click', '.es_seq_list', function(){
		jQuery('.es_seq_list').removeClass('active');
		jQuery(this).addClass('active')
		var seq_id = jQuery(this).data('seq-id');
		var right_panel = jQuery('.es_seq_right_wrapper[data-seq-id="'+seq_id+'"]');
		jQuery('.es_seq_right_wrapper').hide();
		jQuery(right_panel).show();
	});

	/** 
	 * Delay showing/hiding of sequence tabs to allow proper height calculation of content field's WP Editor due to hidden sequences tabs.
	 * Issue: https://core.trac.wordpress.org/ticket/45461
	 */
	setTimeout(function(){
		jQuery('.es_seq_right_wrapper').hide();
		jQuery('.es_seq_list').first().trigger('click');
	},300);

	//all keyup events
	jQuery(document).on('change', '.delay-amount,.delay-unit', function(){
		let sequence_wrapper = jQuery(this).parents('.es_seq_right_wrapper');
		let seq_id       = jQuery(sequence_wrapper).data('seq-id');
		let delay_amount = jQuery(sequence_wrapper).find('.delay-amount').val();
		let delay_unit   = jQuery(sequence_wrapper).find('.delay-unit').val();
		let delay_text   = '';
		if ( 'immediately' === delay_unit ) {
			delay_text += es_admin_data.i18n_data.scheduling_messages.send_immediately;
		} else {
			delay_text += es_admin_data.i18n_data.scheduling_messages.send_after;
			delay_text += ' ' + delay_amount + ' ' + es_admin_data.i18n_data.scheduling_messages[delay_unit];
		}
		jQuery('.es_seq_list.active[data-seq-id="'+seq_id+'"]').find('.js_delay').text(delay_text);
	});

	jQuery(document).on('keyup mouseup', '#email_template_subject', function(){
		let seq_id   = jQuery(this).parents('.es_seq_right_wrapper').data('seq-id');
		let seq_name = jQuery(this).val();
		jQuery('.es_seq_list.active[data-seq-id="'+seq_id+'"]').find('.js_subject').text(seq_name);
	});

	jQuery(document).on('change','#email_template_subject',function(){
		let seq_id   = jQuery(this).parents('.es_seq_right_wrapper').data('seq-id');
		let seq_name = jQuery(this).val();
		jQuery('.es_seq_list.active[data-seq-id="'+seq_id+'"]').find('.js_subject').text(seq_name);
		jQuery(document).trigger('ig_es_sequence_name_updated',[{id:seq_id,name:seq_name}])
	});

	$(document).on('change', '#es_seq_form .delay-unit', function(){
		let delay_unit 		   = $(this).val();
		let delay_amount_field = $(this).prev('.delay-amount');
		let hide_delay_amount_field = 'immediately' === delay_unit;
		if ( hide_delay_amount_field ) {
			$(delay_amount_field).hide();
		} else {
			$(delay_amount_field).show();
		}
	});

	$('#ig-es-import-from-wc-order-btn').on('click',function(e){
		e.preventDefault();
		let elem = $(this);

		let selected_order_statuses = [];
		$('input[name="wc-order-statuses[]"]').each(function(){
			if($(this).is(':checked')) {
				let order_status = $(this).val();
				selected_order_statuses.push(order_status);
			}
		});

		let selected_product_ids = $('#wc-product-ids').val();

		$(elem).find('.es-btn-arrow').hide();
		$(elem).find('.es-btn-loader').show().addClass('animate-spin').attr('disabled', true);

		let order_data = {
			identifier: '',
			order_statuses: selected_order_statuses,
			product_ids: selected_product_ids
		}
		
		$('.ig-es-order-processing-notice').removeClass('hidden');
		ig_es_prepare_import_data_from_wc_orders( order_data );
	});

	$('.ig-es-run-workflow-btn').on('click', function(e){
		let workflow_id  = $(this).data('workflow-id');
		ig_es_run_workflow( workflow_id );
	});
	
	// Find al rating items
	const ratings = document.querySelectorAll(".rating");

	// Iterate over all rating items
	ratings.forEach((rating) => {
	// Get content and get score as an int
	const ratingContent = rating.innerHTML;
	const ratingScore = ratingContent;
	const ratingPercentage = ( ratingScore / 5 ) * 100;

	// Define if the score is good, meh or bad according to its value
	//   const scoreClass =
	//     ratingScore < 40 ? "bad" : ratingScore < 60 ? "meh" : "good";

	//   // Add score class to the rating
	//   rating.classList.add(scoreClass);

	// After adding the class, get its color
	const ratingColor = window.getComputedStyle(rating).backgroundColor;

	// Define the background gradient according to the score and color
	const gradient = `background: conic-gradient(${ratingColor} ${ratingPercentage}%, transparent 0 100%)`;

	// Set the gradient as the rating background
	rating.setAttribute("style", gradient);

	// Wrap the content in a tag to show it above the pseudo element that masks the bar
	rating.innerHTML = `<span>${ratingScore} ${
		ratingContent.indexOf("%") >= 0 ? "<small>%</small>" : ""
	}</span>`;
	});

	// Enable/Disable textarea where we ask option values input for custom fields
	var type = jQuery('#es_cf_type').val();
	var field_type_list = ['checkbox', 'radio', 'dropdown'];
	var options_area = jQuery('.es_custom_field_options');

	if( field_type_list.indexOf(type) >= 0 ){
		options_area.show();
	}

	jQuery("#es_cf_type").change(function() {
		var field_type = jQuery(this).val();
		
		if( field_type_list.indexOf(field_type) >= 0 ){
			options_area.show();
		} else{
			options_area.hide();
		}   

	});

	jQuery('#browser-preview-tab').click(function(){
		jQuery('#send-preview-email-tab').removeClass('active');
		jQuery(this).addClass('active');
		jQuery('#campaign-browser-preview-container').removeClass('hidden');
		jQuery('#campaign-email-preview-container').addClass('hidden');
		jQuery('#campaign-preview-main-container').addClass('w-1/2');
	});
	
	jQuery('#send-preview-email-tab').click(function(){
		jQuery('#browser-preview-tab').removeClass('active');
		jQuery(this).addClass('active');
		jQuery('#campaign-browser-preview-container').addClass('hidden');
		jQuery('#campaign-email-preview-container').removeClass('hidden');
		jQuery('#campaign-preview-main-container').removeClass('w-1/2');
	});

	jQuery('#send-newsletter-preview-email-btn,#send-post_notification-preview-email-btn,#send-post_digest-preview-email-btn').click(function(){
		ig_es_send_campaign_preview_email();
	});

	jQuery('#send-workflow-preview-email-btn').click(function () {
		ig_es_sync_wp_editor_content();
		let template_button = $(this);
		let action_id = template_button.data('action');
		let content = $('textarea[name="ig_es_workflow_data[actions][' + action_id + '][ig-es-email-content]"]').val();
		if (!content) {
			alert(es_admin_data.i18n_data.empty_template_message);
			return;
		}
		let email = $('#ig_es_preview_email_address').val();
		if ('' === email) {
			alert(es_admin_data.i18n_data.empty_email_message);
			return;
		}

		let subject = $('input[name="ig_es_workflow_data[actions][' + action_id + '][ig-es-email-subject]"]').val();
		let heading = $('input[name="ig_es_workflow_data[actions][' + action_id + '][ig-es-email-heading]"]').val();
		let template = $('select[name="ig_es_workflow_data[actions][' + action_id + '][ig-es-email-template]"]').val();

		template_button.addClass('loading');

		let params = {
			type: 'POST',
			url: ajaxurl,
			data: {
				action: 'ig_es_send_workflow_action_test_email',
				es_test_email: email,
				subject: subject,
				content: content,
				heading: heading,
				template: template,
				trigger: $('select[name="ig_es_workflow_data[trigger_name]"]').val(),
				security: ig_es_js_data.security
			},
			dataType: 'json',
			success: function (response) {
				if (response && typeof response.status !== 'undefined' && response.status == "SUCCESS") {
					$(template_button).parent().find('.es-send-success').show();
				} else {
					$(template_button).parent().find('.es-send-error').text(response.message).show();
				}
			},
		};
		$.ajax(params).done(function () {
			$(template_button).removeClass('loading');
		});
	});
});

function ig_es_send_broadcast_preview_email() {

	ig_es_sync_wp_editor_content();
	let content = jQuery('.wp-editor-boradcast').val();
	
	if (jQuery("#wp-edit-es-broadcast-body-wrap").hasClass("tmce-active")){
		content = tinyMCE.activeEditor.getContent();
	}else{
		content = jQuery('.wp-editor-boradcast').val();
	}


	if( !content ){
		alert( es_admin_data.i18n_data.empty_template_message );
		return;
	}

	let email       = jQuery('#es_test_send_email').val();
	let campaign_id = jQuery('#broadcast_id').val();
	if( '' === email ) {
		alert( es_admin_data.i18n_data.empty_email_message );
		return;
	}

	// var tmpl_id = jQuery('#ig_es_broadcast_base_template_id').val();
	let subject = jQuery('#ig_es_broadcast_subject').val();

	let template_button = jQuery('#es_test_email_btn');
	jQuery(template_button).next('.es-loader').show();

	let attachments = [];
	jQuery('input[name="broadcast_data[meta][attachments][]"]').each(function(){
		let attachment = jQuery(this).val();
		attachments.push(attachment);
	});

	let params = {
				type: 'POST',
				url: ajaxurl,
				data: {
					action: 'es_send_test_email',
					es_test_email: email,
					subject: subject,
					content: content,
					attachments: attachments,
					campaign_id: campaign_id,
					security: ig_es_js_data.security
				},
				dataType: 'json',
				success: function(response) {
					if (response && typeof response.status !== 'undefined' && response.status == "SUCCESS") {
						jQuery(template_button).parent().find('.es-send-success').show();
					} else {
						jQuery(template_button).parent().find('.es-send-error').text(response.message).show();
					}
				},
			};
	jQuery.ajax(params).done(function(){
		jQuery(template_button).next('.es-loader').hide();
	});
}

function ig_es_send_campaign_preview_email() {

	ig_es_sync_wp_editor_content();
	let content = jQuery('textarea[name="campaign_data[body]"]').val();
	
	if (jQuery("#edit-es-campaign-body-wrap").hasClass("tmce-active")){
		content = tinyMCE.activeEditor.getContent();
	}


	if( !content ){
		alert( es_admin_data.i18n_data.empty_template_message );
		return;
	}

	let email       = jQuery('#ig_es_preview_email_address').val();
	let campaign_id = jQuery('#campaign_id').val();
	let campaign_type = jQuery('#campaign_type').val();
	if( '' === email ) {
		alert( es_admin_data.i18n_data.empty_email_message );
		return;
	}

	// var tmpl_id = jQuery('#ig_es_broadcast_base_template_id').val();
	let subject = jQuery('#ig_es_campaign_subject').val();

	let template_button = jQuery('#send-newsletter-preview-email-btn,#send-post_notification-preview-email-btn,#send-post_digest-preview-email-btn');
	jQuery(template_button).addClass('loading');

	let attachments = [];
	jQuery('input[name="campaign_data[meta][attachments][]"]').each(function(){
		let attachment = jQuery(this).val();
		attachments.push(attachment);
	});

	let params = {
				type: 'POST',
				url: ajaxurl,
				data: {
					action: 'es_send_test_email',
					es_test_email: email,
					subject: subject,
					content: content,
					attachments: attachments,
					campaign_id: campaign_id,
					campaign_type: campaign_type,
					security: ig_es_js_data.security
				},
				dataType: 'json',
				success: function(response) {
					if (response && typeof response.status !== 'undefined' && response.status == "SUCCESS") {
						jQuery(template_button).parent().find('.es-send-success').show();
					} else {
						jQuery(template_button).parent().find('.es-send-error').text(response.message).show();
					}
				},
			};
	jQuery.ajax(params).done(function(){
		jQuery(template_button).removeClass('loading');
	});
}

function ig_es_run_workflow( workflow_id ) {
	let import_notice_html = `<div class="notice notice-success ig-es-importing-from-wc-orders-notice">
								<p class="text-base font-medium text-gray-600 tracking-wide text-lg ig-es-order-processing-notice">
									${es_admin_data.i18n_data.checking_orders_message}
								</p>
								</div>`; 
	jQuery.ajax({
		type: 'POST',
		url: ajaxurl,
		beforeSend: function() {
			jQuery('.ig-es-importing-from-wc-orders-notice').remove();
			jQuery(import_notice_html).insertAfter('.wp-header-end');
		},
		data: {
			action: 'ig_es_run_workflow',
			workflow_id: workflow_id,
			security: ig_es_js_data.security
		},
		dataType: 'json',
		success: function(response) {
			if (response.success) {
				if ( 'undefined' !== typeof response.data ) {
					let response_data          = response.data;
					let list_ids               = response_data.list_ids;
					let order_statuses         = response_data.order_statuses;
					let date_args              = response_data.date_args;
					let product_list_enabled   = response_data.product_list_enabled;
					let variation_list_enabled = response_data.variation_list_enabled;
					
					let product_ids = []; // 

					let order_data = {
						identifier            : '',
						order_statuses        : order_statuses,
						date_args             : date_args,
						product_ids           : product_ids,
						product_list_enabled  : product_list_enabled,
						variation_list_enabled: variation_list_enabled,
						list_ids              : list_ids
					}
					jQuery(document).on('ig_es_import_finished',() => {
						ig_es_update_workflow_last_ran_at( workflow_id );
					});
					ig_es_prepare_import_data_from_wc_orders( order_data );
				}
			} else {
				alert( ig_es_js_data.i18n_data.ajax_error_message );
			}
		},
		error: function (err) {
			alert( ig_es_js_data.i18n_data.ajax_error_message );
		}
	});
}

function ig_es_update_workflow_last_ran_at( workflow_id ) {
	jQuery.ajax({
		type: 'POST',
		url: ajaxurl,
		data: {
			action: 'ig_es_update_workflow_last_ran_at',
			workflow_id: workflow_id,
			security: ig_es_js_data.security
		},
		dataType: 'json',
		success: function(response) {
			if (response.success && 'undefined' !== typeof response.data) {
				if ( '' !== response.data.last_ran_at ) {
					jQuery('#the-list .last_ran_at_date_time[data-workflow-id="' + workflow_id + '"]').text(response.data.last_ran_at);
				}
			}
		},
		error: function (err) {
		}
	});
}

function ig_es_prepare_import_data_from_wc_orders( order_data ) {
	let data = order_data;
	data.action   = 'ig_es_prepare_import_data_from_wc_orders';
	data.security = ig_es_js_data.security;
	jQuery.ajax({
		type: 'POST',
		url: ajaxurl,
		data: data,
		dataType: 'json',
		success: function(response) {
			if (response.success) {
				if ( 'undefined' !== typeof response.data ) {
					let response_data = response.data;
					if( response_data.success && response_data.total_orders_count > 0 ) {
						let total_orders_count           = response_data.total_orders_count;
						let total_processed_orders_count = response_data.total_processed_orders_count;
						let total_matched_orders_count   = response_data.total_matched_orders_count;
						let order_stats_html             = response_data.order_stats_html;

						order_data.identifier                   = response_data.identifier;
						order_data.total_orders_count           = total_orders_count;
						order_data.total_processed_orders_count = total_processed_orders_count;
						order_data.total_matched_orders_count   = total_matched_orders_count;

						jQuery('.ig-es-order-processing-notice').html(order_stats_html);
						// Check if we have processed all orders.
						if ( total_processed_orders_count === total_orders_count ) {
							// If we are on the subscribers import screen then trigger get_import_data to show the mapping UI
							if ( jQuery('#form_import_subscribers').length ) {
								jQuery(document).trigger('ig_es_get_import_data', [{identifier:order_data.identifier}]);
							} else {
								// Add progress bar HTML
								jQuery('.ig-es-importing-from-wc-orders-notice').html(`<div class="step2 w-full overflow-auto mb-2 mr-4 mt-2 border-b border-gray-100">
								<h2 class="import-status text-base font-medium text-gray-600 tracking-wide"></h2>
								<div class="step2-body overflow-auto pb-4"></div>
								<p class="import-instruction text-base font-medium text-yellow-600 tracking-wide"></p>
								<div id="importing-progress" class="importing-progress hidden mb-4 mr-2 text-center"><span class="bar" style="width:0%"><p class="block import_percentage text-white font-medium text-sm"></p></span></div>
							</div>`);
								let import_data = {
									identifier   : order_data.identifier,
									mapping_order: ['email','first_name','last_name'],
									list_id      : order_data.list_ids,
									status       : 'subscribed'
								}

								if( order_data.product_list_enabled || order_data.variation_list_enabled ) {
									import_data.mapping_order.push( 'list_name' );
								}
								jQuery(document).trigger('ig_es_trigger_import',[import_data]);
							}
						} else {
							ig_es_prepare_import_data_from_wc_orders( order_data );
						}
					} else {
						if ( jQuery('#form_import_subscribers').length ) {
							let target_elem = jQuery('#ig-es-import-from-wc-order-btn');
							let message = response_data.message;
							jQuery(target_elem).find('.es-btn-arrow').show();
							jQuery(target_elem).find('.es-btn-loader').hide().removeClass('animate-spin').removeAttr('disabled');
							jQuery('.ig-es-order-processing-notice').removeClass('text-green-500').addClass('text-red-600').html( message );
						} else {
							let message = response_data.message;
							jQuery('.ig-es-importing-from-wc-orders-notice').addClass('error').find('p').html( message );
						}
					}
				} else {
					alert( ig_es_js_data.i18n_data.ajax_error_message );
				}
			} else {
				alert( ig_es_js_data.i18n_data.ajax_error_message );
			}
		},
		error: function (err) {
			alert( ig_es_js_data.i18n_data.ajax_error_message );
		}
	});
}

//Bounce handling
jQuery(document).on('click', 'div[data-copy="true"]' , function(e) {
    var copyBtn = jQuery(this);
    var text = copyBtn.data('copyurl');
    navigator.clipboard.writeText(text.trim());
    copyBtn.find('svg').removeClass('text-blue-500');
    copyBtn.find('svg').addClass('text-green-500');
    setTimeout(function(){
        copyBtn.find('svg').removeClass('text-green-500');
        copyBtn.find('svg').addClass('text-blue-500');
    }, 2000);
});