<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Get logged in customer
 * 
 * @since 4.6.5
 *
 * @return IG_ES_Customer|bool
 */
function ig_es_get_logged_in_customer() {
	if ( ! is_user_logged_in() ) {
		return false;
	}
	return IG_ES_Customer_Factory::get_by_user_id( get_current_user_id() );
}

