<?php
$template_1 = array(
	'es_templ_heading' => 'How you can be a hero, {{FIRSTNAME}} 💓',
	'es_templ_body'    => '
<table border="0" width="100%" cellspacing="0" cellpadding="0">
<tbody>
<tr>
<td>
<table style="border-collapse: collapse;" border="0" width="600" cellspacing="0" cellpadding="0" align="center">
<tbody>
<tr>
<td align="center"><img class="center fixedwidth es-logo" title="Image" src="' . ES_PLUGIN_URL . 'pro/templates/images/dummy-logo-400x80.png" alt="Image" width="149" align="center" border="0" /></td>
</tr>
<tr style="border-radius: 10px 10px 0 0;">
<td><img class="center autowidth es-charity-banner" title="Image" src="' . ES_PLUGIN_URL . 'pro/templates/images/charity1.jpg" alt="Image" width="745" align="center" border="0" /></td>
</tr>
<tr class="es-side-border">
<td>
<p class="es-quote"><strong style="color: #0b3f4a;">"In a gentle way, you can shake the world."</strong></p>
</td>
</tr>
<tr class="es-side-border">
<td>
<p class="es-message es-recipients">Dear {{FIRSTNAME}},</p>
<p class="es-message es-msg1">We here at Icegram would like to thank you for being a part of our community.</p>
<p class="es-message es-msg2">We’re happy to announce that we’re launching a new online fundraising initiative! This campaign is raising funds for [purpose of the campaign], and will be essential for us to continue our work into the coming season. Would you please consider making a donation of to help us kick off our campaign?</p>
</td>
</tr>
<tr class="es-side-border">
<td>
<div style="margin: 15px 0 10px 0; padding: 2px;" align="center"><a class="es-button" href="#" target="_blank" rel="noopener noreferrer"><span class="es-button-text">Donate</span></span></a></div></td>
</tr>
<tr bgcolor="#0b3f4a">
<td align="center"><img class="center fixedwidth es-footer-logo" title="Image" src="' . ES_PLUGIN_URL . 'pro/templates/images/logo-footer_6.png" alt="Image" width="149" h align="center" border="0" /></td>
</tr>
<tr bgcolor="#0b3f4a">
<td style="padding: 10px 0 0 0;">
<p class="es-info"><span style="">For more information follow us</span></p>
</td>
</tr>
<tr bgcolor="#0b3f4a">
<td class="es-footer"><img class="es-social-icon" title="Custom" src="' . ES_PLUGIN_URL . 'pro/templates/images/Instagram.png" alt="Custom" width="32" height="32" /> <img class="es-social-icon" title="Custom" src="' . ES_PLUGIN_URL . 'pro/templates/images/Facebook.png" alt="Custom" width="32" height="32" /> <img class="es-social-icon" title="Custom" src="' . ES_PLUGIN_URL . 'pro/templates/images/Twitter.png" alt="Custom" width="32" height="32" /></a></td>
</tr>
</tbody>
</table>
</td>
</tr>
</tbody>
</table>',
	'es_templ_status'  => 'Published',
	'es_email_type'    => 'newsletter',
	'es_custom_css'    => '<style type="text/css">
															.es-logo{
		text-decoration: none; 
		border: 0; 
		height: auto; 
		width: 100%; 
		max-width: 149px; 
		display: block;
	}
	.es-charity-banner{
		border-radius: 20px 20px 0 0; 
		text-decoration: none; 
		border: 0; 
		height: auto; 
		width: 100%;
		max-width: 745px; 
		display: block;
	}
	.es-side-border{
		border-left: 1px solid #F0F0F0; 
		border-right: 1px solid #F0F0F0;
	}
	.es-quote{
		font-size: 30px; 
		padding: 10px 0 10px 3px; 
		line-height: 1.2; 
		text-align: center; 
		color: #ffffff; 
		word-break: break-word; 
		font-family: Roboto, Tahoma, Verdana, Segoe, sans-serif; 
		margin: 0;
	}
	.es-message{
		line-height: 1.5; 
		color: #707070; 
		word-break: break-word; 
		font-family: Roboto, Tahoma, Verdana, Segoe, sans-serif; 
		margin: 0;
	}
	.es-msg1{
		font-size: 16px; 
		padding: 15px 10px 10px 15px; 
		line-height: 1.2;
	}
	.es-msg2{
		font-size: 16px; 
		padding: 0 10px 0 15px;
	}
	.es-recipients{
		font-size: 20px; 
		padding: 15px 10px 0 15px;
	}
	.es-button{
		text-decoration: none; 
		display: inline-block; 
		color: #0e3d89; 
		background-color: #af1f17; 
		border-radius: 4px; 
		width: auto; 
		padding: 5px 0 5px 0;  
		font-family: Roboto, Tahoma, Verdana, Segoe, sans-serif; 
		text-align: center; 
		word-break: keep-all; 
		border: 1px solid #ffffff;
	}
	.es-button-text{
		padding-left: 60px; 
		padding-right: 60px; 
		font-size: 16px; 
		display: inline-block;
		font-size: 16px; 
		line-height: 2; 
		word-break: break-word; 
		color: #ffffff;
	}
	.es-footer-logo{
		margin: 15px 0 0 0; 
		text-decoration: none; 
		border: 0; 
		height: 50%; 
		width: auto; 
		display: block;
	}
	.es-info{
		color: #ffffff; 
		line-height: 2.5; 
		text-align: center;
		word-break: break-word; 
		font-family: Roboto, Tahoma, Verdana, Segoe, sans-serif; 
		margin: 0;
		font-size: 14px;
	}
	.es-footer{
		border-radius: 0 0 10px 10px; 
		text-align: center; 
		padding: 0 3px 15px 3px; 
	}
	.es-social-icon{
		text-decoration: none; 
		height: auto; 
		border: none;
	}

													</style>',
	'es_thumbnail'     => ES_PLUGIN_URL . 'pro/templates/images/template-nl-12.png'
);

return $template_1;
