<?php
$template_1 = array(
	'es_templ_heading' => 'Hurry!! This offer ends in a few hours',
	'es_templ_body'    => '<div class="es-container">
											<div class="es-logo"><img src="' . ES_PLUGIN_URL . 'pro/templates/images/icegram-logo-branding-44-grey.png" alt="" width="44" height="44" class="aligncenter size-full wp-image-12414" /></div>
											<div class="es-headline">
												<div class="es-main-headline"> Get flat 40% OFF today </div>
												<div class="es-sub-headline">Valid on all products</div>
											</div>
										        <div class="es-button">Buy Now</div>
											<div class="es-message">Get your hands on your favourite products at the best prices before we close the deal.</div>
											
											<div class="es-coupon">CODE: CYBER40</div>
											<div class="es-pre-foorter">Use coupon code directly at checkout.
										        Sale ends Monday, November 27 at midnight CST. </div>
											<div class="es-foorter">
												<div class="es-company-name"><h1>Your Company Name</h1></div>
												<div class="es-unsubscribe">Landmark, Building Number, Street, City, Zip Code</div>
											</div>
									    </div>',
	'es_templ_status'  => 'Published',
	'es_email_type'    => 'newsletter',
	'es_custom_css'    => '<style>
											.es-container{
											    width: 100%;
											    max-width: 600px;
											    height: auto;
											    margin: 0 auto;
											    background-color: #FFFFFF;
											    padding: 2em;
											    border: 1px solid #CCC;
											    /*text-align: center;U*/ 
											    font-family: "system", sans-serif;
											    word-wrap: break-word;
											}
											.es-logo {
											    text-align: center;
											   padding-bottom:1em;
											}
											.es-headline{
											  background-color:#000;
											        color:#FFF;
											        padding:2em;
											}
											.es-main-headline{
											     font-size: 8em;
											     line-height: 1.2em;
											}
											.es-sub-headline{
											    font-size: 3em;
											    color: #CCC;
											    padding-top: 1em;
											    line-height: 1;
											}
											.es-message{
											    font-weight: normal;
											    font-size: 17px;
											    line-height: 1.55;
											    padding: 2em 1.5em 0 1.5em;
											    margin: 0 0 2em 0;
											}
											.es-button{
											    border-width: 0;
											    color: white;
											    background-color: #0099ff;
											    width: 25%;
											    padding: 1em 2em;
											    font-family: "system", sans-serif;
											    font-weight: bold;
											    display: block;
											    text-decoration: none;
											    margin-top: 3em;
											    margin-right: auto;
											    margin-left: auto;
											    border-radius: 4px;
											    text-align: center;
											}
											.es-coupon{
											    font-family: "system", sans-serif;
											    text-transform: uppercase;
											    letter-spacing: 1px;
											    font-weight: bold;
											    padding-left: 1em;
											    font-size: 2em;
											    line-height: 1;
											 text-align: center;
											}
											.es-pre-foorter{
											    font-weight: normal;
											    line-height: 1.55;
											    font-size: 13px;
											    font-style: italic;
											    color: #bcbec0;
											    font-family: "system", sans-serif;
											  padding-left: 2em;
											    padding-top: 1em;
											 text-align: center;
											}
											.es-foorter{
											    font-family: "system", sans-serif;
											    line-height: 1.5;
											    color: #888;
											    text-align: center;
											    padding: 2em 6em 2em 6em;
											}
											.es-company-name{
											    font-family: "system", sans-serif;
											    font-weight: bold;
											    color: #333;
											    font-size: 14px;
											    padding: 0;
											    margin: 1em 0 1em 0;
											}
											.es-unsubscribe{
											    font-weight: normal;
											    line-height: 1.55;
											    font-size: 11px;
											    padding: 0 1.5em 0 1.5em;
											    margin: 0 0 2em 0;
											}
											/* Define the "system" font family */
											@font-face {
											  font-family: system;
											  font-style: normal;
											  font-weight: 300;
											  src: local(".SFNSText-Light"), local(".HelveticaNeueDeskInterface-Light"), local(".LucidaGrandeUI"), local("Ubuntu Light"), local("Segoe UI Light"), local("Roboto-Light"), local("DroidSans"), local("Tahoma");
											}
											@media only screen and (max-width: 319px), (min-width: 320px) and (max-width: 359px), (min-width: 360px) and (max-width: 413px), (min-width: 414px) and (max-width: 643px), (min-width: 644px) and (max-width: 767px) {
											.es-container{
											   padding: 2em 0.2em;
											 }
											.es-main-headline {
											   font-size: 5em;
											}
											.es-button{
											    width: 35%;
											}
											.es-coupon{
											   padding-left:  0;
											 }
											.es-foorter{
											 padding:  0;
											  }
											}
											@media only screen and (min-width: 768px) and (max-width: 992px), (min-width: 993px) and (max-width: 1023px), (min-width: 1024px) and (max-width: 1035px), (min-width: 1036px) and (max-width: 1044px) {
											.es-container{
											   width: 90%;
											  }
											}
											</style>',
	'es_thumbnail'     => ES_PLUGIN_URL . 'pro/templates/images/coupon_thumb.png'
);

return $template_1;
