<?php
$template_1 = array(
	'es_templ_heading' => '{{POSTTITLE}}',
	'es_templ_body'    => '<div class="es-container">
										      <div class="es-logo">
										        <img src="' . ES_PLUGIN_URL . 'pro/templates/images/icon_100.png" alt="" width="51" height="51" class="aligncenter size-full wp-image-12420" />
										      </div>
										      <div class="es-description es-name">Hi {{NAME}}, </div>
										      <div class="es-description">I just published my latest blog post.</div>
										      <div class="es-headline"><a  href="{{POSTLINK-ONLY}}" target="_bank">{{POSTTITLE}}</a></div>
										      <div class="es-message">
										          <div class="es-left-message">{{POSTIMAGE}}</div>
										          <div class="es-text-message">
										              <div class="es-description"><span class="es-text">So take a peek and feel free to join the discussion.</span><br/>
										              {{POSTDESC}}</div>
										          </div>
										          <div style="clear:both"></div>
										      </div>
										      <div class="es-button"><a href="{{POSTLINK-ONLY}}" target="_bank">Join the discussion</a></div>
										</div>',
	'es_templ_status'  => 'Published',
	'es_email_type'    => 'post_notification',
	'es_custom_css'    => '<style type="text/css">
												.es-container{
												    box-shadow: 0 0 8px 0 rgba(0, 0, 0, 0.1);
												    background: #FFFFFF;
												    color: #666;
												    width: 100%;
												    max-width: 600px;
												    height: auto;
												    margin: 0 auto;
												    padding: 2em;
												    font-family: "system", sans-serif;
												}
												.es-logo {
												    text-align: center;
												    margin-bottom: 1em;
												}
												.es-headline{
												    box-shadow: none;
												    border: 0;
												    text-align: left;
												    font-size: 2em;
												    line-height: 1.5em;
												    color: #f5ba45;
												}
												.es-headline a{
												text-decoration:none;
												color:inherit;
												}
												.es-text{
												color:black;
												font-size:1.2em;
												}
												.es-message{
												    padding: 1em 2em;
												}
												.alignleft {
												    padding-right: 2em;
												}
												.es-text-message {
												  display: inline;
												    width: 53%;
												    float: right;
												    padding-left: 0.2em;
												}

												.es-description {
												    font-size: 1.2em;
												    line-height: 1.7em;
												}
												.es-left-message{
												    float: left;
												    width: 40%;
												}
												.es-left-message img{
												  max-width: 100%;
												  max-height: 300px;
												}
												.es-button{
												    text-align: center;
												}
												.es-button a{
												    padding:  0.5em;
												    font-size: 1.2em;
												    background-color:#f5ba45;
												    color: #FFFFFF;
												   text-decoration: none;
												}
												@media only screen and (max-width: 319px), (min-width: 320px) and (max-width: 359px),  (min-width: 360px) and (max-width: 413px), (min-width: 414px) and (max-width: 643px), (min-width: 644px) and (max-width: 767px) {
												.es-container {
												padding-right: 1em;
												    width: 80%;
												}
												.es-message{
												   padding-left: 0;
												}
												.es-left-message{
												    width: 100%;
												   }
												.es-text-message{
												    width: 100%;
												   }
												}
												/* Define the "system" font family */
												@font-face {
												  font-family: system;
												  font-style: normal;
												  font-weight: 300;
												  src: local(".SFNSText-Light"), local(".HelveticaNeueDeskInterface-Light"), local(".LucidaGrandeUI"), local("Ubuntu Light"), local("Segoe UI Light"), local("Roboto-Light"), local("DroidSans"), local("Tahoma");
												}
												</style>',
	'es_thumbnail'     => ES_PLUGIN_URL . '/pro/templates/images/hero_thumb.png'
);

return $template_1;
