<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Variable class to get value for {{cart.item_count}} placeholder
 */
class IG_ES_Variable_Cart_Item_Count extends IG_ES_Workflow_Variable {

	/**
	 * Method to set description and other admin props
	 *
	 */
	public function load_admin_details() {
		$this->description = __( 'Displays the number of the items in cart.', 'email-subscribers' );
	}

	/**
	 * Get cart items' count
	 * 
	 * @param IG_ES_Cart $cart
	 * @param array $parameters
	 * @return string
	 */
	public function get_value( $cart, $parameters ) {
		return $cart->get_item_count();
	}
}

return new IG_ES_Variable_Cart_Item_Count();
