<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Variable class to get value for {{guest.id}} placeholder
 */
class IG_ES_Variable_Guest_ID extends IG_ES_Workflow_Variable {

	/**
	 * Method to set description and other admin props
	 *
	 */
	public function load_admin_details() {
		$this->description = __( 'Displays the guest\'s id.', 'email-subscribers');
	}


	/**
	 * Get guest id
	 * 
	 * @param IG_ES_Guest $guest
	 * @param array $parameters
	 * @return string
	 */
	public function get_value( $guest, $parameters ) {
		return $guest->get_id();
	}
}

return new IG_ES_Variable_Guest_ID();
